{$O+} {$I Define.inc}
unit _DBTUnit;
interface
uses Objects, DAE, DAE_Type, Ext_Type;
const
  DefExt = '.dbt';

type
  PDBT3Memo = ^TDBT3Memo;
  TDBT3Memo = object(TMemoFile)
     MemoStream:PDBStream;
     constructor Init(AOwner:PDataSet);
     destructor Done;virtual;
     function GetSize(Offset:LongInt):Word;virtual;
     procedure Get(Offset:LongInt;var D:TMemoRec);virtual;
     procedure AtFree(Offset:LongInt);virtual;
     function Put(var D:TMemoRec):LongInt;virtual;
     procedure RenameMemo;virtual;
     procedure Open;virtual;
     procedure Close;virtual;
  end;

type
  PDBT4header = ^TDBT4header;
  TDBT4header = record
     FirstFree:Longint;
     Reserved:longint;
     DbfName:array [1..8] of char;
     Flag3:byte;
     Reserved2:array [1..3] of byte;
     BlokSize:TrueWord;
  end;

type
  PDBT4Memo = ^TDBT4Memo;
  TDBT4Memo = object(TMemoFile)
     MemoStream:PDBStream;
     Header:PDBT4header;
     constructor Init(AOwner:PDataSet);
     destructor Done;virtual;
     function GetSize(Offset:LongInt):Word;virtual;
     procedure Get(Offset:LongInt;var D:TMemoRec);virtual;
     procedure AtFree(Offset:LongInt);virtual;
     function Put(var D:TMemoRec):LongInt;virtual;
     procedure RenameMemo;virtual;
     procedure Close;virtual;
     procedure Open;virtual;
  end;

function CreateDBT3MemoFile(ADataSet:PDataSet):PMemoFile;far;
function CreateDBT4MemoFile(ADataSet:PDataSet):PMemoFile;far;
implementation
uses Ext_Dos, Ext_Math, Ext_Str;

function CreateDBT3MemoFile(ADataSet:PDataSet):PMemoFile;
begin
   CreateDBT3MemoFile:=New(PDBT3Memo, Init(ADataSet));
end;

function CreateDBT4MemoFile(ADataSet:PDataSet):PMemoFile;
begin
   CreateDBT4MemoFile:=New(PDBT4Memo, Init(ADataSet));
end;

 { TDBT3Memo }
constructor TDBT3Memo.Init(AOwner:PDataSet);
begin
  inherited Init(Owner);
  AssignStr(FileName, ReplaceExt(AOwner^.TableName^, DefExt, true));
  Open;
end;

procedure TDBT3Memo.Open;
procedure DoCreate;
var P:Pointer;
begin
  MemoStream:=New(PDBStream, Init(FileName^, stCreate));
  GetMem(P, 512);
  FillChar(P^,512,0);
  PLongint(P)^:=1;
  MemoStream^.Write(P^, 512);
  FreeMem(P, 512);
end;
begin
  MemoStream:=Session^.GetDBStream(FileName^);
  if MemoStream=nil then
  begin
     if FileExists(FileName^) then
       MemoStream:=New(PDBStream, Init(FileName^, stOpen))
     else DoCreate;
  end;
end;

procedure TDBT3Memo.Close;
begin
  Session^.FreeDBStream(MemoStream);
end;


destructor TDBT3Memo.Done;
begin
  Close;
  inherited Done;
end;

function TDBT3Memo.GetSize(Offset:LongInt):Word;
var A:array[1..512] of Char;
    len,i,c:word;
    Stop:boolean;
begin
  if Offset=0 then GetSize:=0
  else
  begin
    Offset:=Offset*512;
    Len:=0;
    MemoStream^.Seek(Offset);
    Stop:=false;
    while (not Stop) and (MemoStream^.Status=stOk) and
        (MemoStream^.GetSize>MemoStream^.GetPos) do
    begin
      if 512<MemoStream^.GetSize-MemoStream^.GetPos then C:=512
      else C:=MemoStream^.GetSize-MemoStream^.GetPos;
      MemoStream^.Read(A, C);
      i:=FindChar(A,512,#$1A);
{$IFDEF VER70}
      asm
          MOV   AX,Len
          CMP   i,0
          JZ    @@1
          ADD   AX,I
          DEC   AX
          MOV   Stop,1
          JMP   @@2
@@1:      ADD   AX,C
@@2:      MOV   Len,AX
      end;
{$ELSE}
    Stop:=i=0;
    if Stop then Len:=Len+i-1
    else Len:=Len+C;
{    asm
          MOV   AX,Len
          CMP   i,0
          JZ    @@1
          ADD   AX,I
          DEC   AX
          MOV   Stop,1
          JMP   @@2
@@1:      ADD   AX,C
@@2:      MOV   Len,AX
    end;}
{$ENDIF}
    end;
    if MemoStream^.Status<>stOk then MemoStream^.Reset;
    GetSize:=len;
  end;
end;

procedure TDBT3Memo.Get(Offset:LongInt;var D:TMemoRec);
var A:array[1..512] of Char;
    l,i,c:word;
    Stop:boolean;
begin
  if Offset<>0 then
  begin
    Offset:=Offset*512;
    L:=0;
    MemoStream^.Seek(Offset);
    Stop:=false;
    while (not Stop) and (MemoStream^.Status=stOk) and
        (MemoStream^.GetSize>MemoStream^.GetPos) do
    begin
      if 512<MemoStream^.GetSize-MemoStream^.GetPos then C:=512
      else C:=MemoStream^.GetSize-MemoStream^.GetPos;
      MemoStream^.Read(A, C);
      for i:=1 to C do
         if A[i]=#$1A then
         begin
           stop:=true;
           break;
         end
         else
         begin
           if (i<c) and (A[i]=#$8D) and (A[i+1]=#$0A) then A[i]:=#$0D;
           D.Text[L+i-1]:=A[i];
         end;
      if Stop then inc(L,i) else inc(l,C);
    end;
    D.Length:=L;
    if MemoStream^.Status<>stOk then MemoStream^.Reset;
  end;
end;

procedure TDBT3Memo.AtFree(Offset:LongInt);
begin
end;

function TDBT3Memo.Put(var D:TMemoRec):LongInt;
var Len, ALen:Longint;
    P:Pointer;
    C:Char;
begin
  MemoStream^.Seek(MemoStream^.GetSize);
  Len:=MemoStream^.GetSize;
  if Len mod 512<>0 then {塞 䠩}
  begin
    ALen:=512 - (Len mod 512);
    GetMem(P, ALen);
    FillChar(P^, ALen, 0);
    MemoStream^.Write(P^, ALen);
    FreeMem(P, ALen);
  end;
  C:=#$1A;
  Len:=MemoStream^.GetSize div 512;
  Put:=Len;
  MemoStream^.Write(D.Text, D.Length);
  MemoStream^.Write(C, SizeOf(Char));
end;

procedure TDBT3Memo.RenameMemo;
var NewName:string;
begin
  NewName:=ReplaceExt(Owner^.TableName^, defExt, true);
  if FileExists(NewName) then DeleteFile(NewName);
  RenameFile(FullName(FileName^), FullName(NewName));
  AssignStr(FileName, NewName);
end;

 { TDBT4Memo }

constructor TDBT4Memo.Init(AOwner:PDataSet);
begin
  inherited Init(AOwner);
  AssignStr(FileName, ReplaceExt(AOwner^.TableName^, DefExt, true));
end;

procedure TDBT4Memo.Open;
var s:string;
begin
  MemoStream:=Session^.GetDBStream(FileName^);
  if MemoStream=nil then
  begin
    if FileExists(FileName^) then
       MemoStream:=New(PDBStream, Init(FileName^, Owner^.Mode))
    else MemoStream:=New(PDBStream, Init(FileName^, stCreate));
    Header:=MemoStream^.CreateInfoBlock(SizeOf(TDBT4header));
    if MemoStream^.GetSize>0 then
    begin
      MemoStream^.Seek(0);
      MemoStream^.Read(Header^, SizeOf(TDBT4header));
    end
    else
    begin
      FillChar(Header^, SizeOf(TDBT4header), 0);
      s:=ExtractName(Owner^.TableName^);
      Move(S[1], Header^.DbfName, Min(Length(S),8));
      Header^.BlokSize:=$200;
      Header^.FirstFree:=Header^.BlokSize;
    end;
  end
  else Header:=MemoStream^.Info;
end;

procedure TDBT4Memo.Close;
begin
  Session^.FreeDBStream(MemoStream);
end;

destructor TDBT4Memo.Done;
begin
  Close;
  inherited Done;
end;

function TDBT4Memo.GetSize(Offset:LongInt):Word;
var
  L:Longint;
begin
  if Offset=0 then L:=0
  else
  begin
    MemoStream^.Seek(Offset*Header^.BlokSize+SizeOf(Longint));
    MemoStream^.Read(L,SizeOf(Longint));
  end;
  GetSize:=L;
end;

procedure TDBT4Memo.Get(Offset:LongInt;var D:TMemoRec);
var
  L,i:Longint;
begin
  MemoStream^.Seek(Offset*Header^.BlokSize+SizeOf(Longint));
  MemoStream^.Read(L,SizeOf(Longint));
  MemoStream^.Read(D.Text,L);
  for i:=0 to L-1 do
  if (i<l-1) and (D.Text[i]=#$8D) and (D.Text[i+1]=#$0A) then D.Text[i]:=#$0D;
  D.Length:=L;
{  if Assigned(Owner^.LangDriver) then Owner^.LangDriver(D.Text, L, false);}
  if Owner^.CodePageDrv<>nil then Owner^.CodePageDrv^.BufConvertTO(D.Text,L);
end;

procedure TDBT4Memo.AtFree(Offset:LongInt);
var
  L:Longint;
begin
{  MemoStream^.Seek(Offset*Header^.BlokSize);
  MemoStream^.Write(Header^.FirstFree,SizeOf(Longint));
  Header^.FirstFree:=Offset;
  MemoStream^.Seek(0);
  MemoStream^.Write(Header^.FirstFree,SizeOf(Longint));}
end;

function TDBT4Memo.Put(var D:TMemoRec):LongInt;
var L:Longint;
    P:PByteArray;
begin
  L:=MemoStream^.GetSize mod Header^.BlokSize;
  if L<>0 then
  begin
    L:=Header^.BlokSize - l;
    GetMem(P,L);
    FillChar(P^, L, 0);
    MemoStream^.Seek(MemoStream^.GetSize);
    MemoStream^.Write(P^,L);
    FreeMem(P,L);
  end;
  MemoStream^.Seek(MemoStream^.GetSize);
  L:=$0008FFFF;
  MemoStream^.Write(L,SizeOf(Longint));
  L:=D.Length;
  MemoStream^.Write(L,SizeOf(Longint));
  Put:=MemoStream^.GetSize div Header^.BlokSize;
{  if Assigned(Owner^.LangDriver) then Owner^.LangDriver(D.Text, D.Length, true);}
  if Owner^.CodePageDrv<>nil then Owner^.CodePageDrv^.BufConvertFROM(D.Text,D.Length);
  MemoStream^.Write(D.Text,D.Length);
{  if Assigned(Owner^.LangDriver) then Owner^.LangDriver(D.Text, D.Length, false);}
  if Owner^.CodePageDrv<>nil then Owner^.CodePageDrv^.BufConvertTO(D.Text,D.Length);
  L:=D.Length mod Header^.BlokSize;
  if L<>0 then
  begin
    L:=Header^.BlokSize - l;
    GetMem(P,L);
    FillChar(P^, L, 0);
    MemoStream^.Seek(MemoStream^.GetSize);
    MemoStream^.Write(P^,L);
    FreeMem(P,L);
  end;
  Header^.FirstFree:=MemoStream^.GetSize;
  MemoStream^.Seek(0);
  MemoStream^.Write(Header^.FirstFree,SizeOf(Longint));
end;

procedure TDBT4Memo.RenameMemo;
var NewName:string;
begin
  NewName:=ReplaceExt(Owner^.TableName^, defExt, true);
  if FileExists(NewName) then DeleteFile(NewName);
  RenameFile(FullName(FileName^), FullName(NewName));
  AssignStr(FileName, NewName);
end;

end.
