{************************************************}
{                                                }
{   Turbo Pascal 7.0                             }
{   FreePacal                                    }
{   Delphi 4                                     }
{   Extended string functions                    }
{                                                }
{   Copyright (c) 1995-98 by Alexs               }
{                                                }
{************************************************}

{$IFDEF VER70}
{$O+}
{$ENDIF}
{$I Define.inc}
unit Storage;
interface
uses Objects, Views, Clases, Register;

type
  TPropType = (ptNone, ptString, ptInteger, ptFloat, ptBoolean, ptBlob);

type
  PPropObject = ^TPropObject;
  TPropObject = object(TObject)
    Name:PString;
    DateType:TPropType;
    constructor Init(AName:string);
    constructor Load(var S:TStream);
    destructor Done;virtual;
    procedure Store(var S:TStream);
    function AsString:string;virtual;
    function AsInteger:integer;virtual;
    function AsBoolean:boolean;virtual;
    function AsFloat:Double;virtual;
    function DataSize:word;virtual;
    procedure AsBlob(var Buffer);virtual;
    procedure SetAsString;virtual;
    procedure SetAsInteger;virtual;
    procedure SetAsBoolean;virtual;
    procedure SetAsFloat;virtual;
    procedure SetAsBlob(var Buffer);virtual;
  end;

{type
  PStringProp = ^TStringProp;
  TStringProp = object(TPropObject)
    Value:PString;
    constructor Init(AName, AValue:string);
    constructor Load(var S:TStream);
    destructor Done;virtual;
    procedure Store(var S:TStream);
    function AsString:string;virtual;
    function DataSize:word;virtual;
    procedure SetAsString;virtual;
  end;

type
  PPropInteger = ^TPropInteger;
  TPropInteger = object(TPropObject)
    Value:Longint;
    constructor Init(AValue:Longint);
    constructor Load(var S:TStream);
    destructor Done;virtual;
    procedure Store(var S:TStream);
    function AsString:string;virtual;
    function AsInteger:integer;virtual;
    function AsBoolean:boolean;virtual;
    function AsFloat:Double;virtual;
    function DataSize:word;virtual;
    procedure AsBlob(var Buffer);virtual;
    procedure SetAsString;virtual;
    procedure SetAsInteger;virtual;
    procedure SetAsBoolean;virtual;
    procedure SetAsFloat;virtual;
    procedure SetAsBlob(var Buffer);virtual;
  end;

type
  PPropObject = ^TPropObject;
  TPropObject = object(TObject)
    constructor Init(AValue:string)
    constructor Load(var S:TStream);
    destructor Done;virtual;
    procedure Store(var S:TStream);
    function AsString:string;virtual;
    function AsInteger:integer;virtual;
    function AsBoolean:boolean;virtual;
    function AsFloat:Double;virtual;
    function DataSize:word;virtual;
    procedure AsBlob(var Buffer);virtual;
    procedure SetAsString:string;virtual;
    procedure SetAsInteger:integer;virtual;
    procedure SetAsBoolean:boolean;virtual;
    procedure SetAsFloat:Double;virtual;
    procedure SetAsBlob(var Buffer);virtual;
  end;

type
  PPropObject = ^TPropObject;
  TPropObject = object(TObject)
    constructor Init(AValue:string)
    constructor Load(var S:TStream);
    destructor Done;virtual;
    procedure Store(var S:TStream);
    function AsString:string;virtual;
    function AsInteger:integer;virtual;
    function AsBoolean:boolean;virtual;
    function AsFloat:Double;virtual;
    function DataSize:word;virtual;
    procedure AsBlob(var Buffer);virtual;
    procedure SetAsString:string;virtual;
    procedure SetAsInteger:integer;virtual;
    procedure SetAsBoolean:boolean;virtual;
    procedure SetAsFloat:Double;virtual;
    procedure SetAsBlob(var Buffer);virtual;
  end;
type
  PPropObject = ^TPropObject;
  TPropObject = object(TObject)
    function AsString:string;virtual;
    function AsInteger:integer;virtual;
    function AsBoolean:boolean;virtual;
    function AsFloat:Double;virtual;
    function DataSize:word;virtual;
    procedure AsBlob(var Buffer);virtual;
    procedure SetAsString:string;virtual;
    procedure SetAsInteger:integer;virtual;
    procedure SetAsBoolean:boolean;virtual;
    procedure SetAsFloat:Double;virtual;
    procedure SetAsBlob(var Buffer);virtual;
  end;

  PPropCollection = ^TPropCollection;
  TPropCollection = object(TSortedCollection)
    function Compare(Key1, Key2: Pointer): Integer; virtual;
  end;

  PReader = ^TReader;
  TReader = object(TObject)
    constructor Init(var S:TStream);
    destructor Done;virtual;
  end;

  PWriter = ^TWriter;
  TWriter = object(TObject)
    constructor Init;
    destructor Done;virtual;
    procedure Store(var S:TStream);
  end;

type
  PPersistent = ^TPersistent;
  TPersistent = object(TObject)
    constructor Init;
    constructor Load(var S:TStream);
    destructor Done;virtual;
    procedure Store(var S:TStream);
    procedure ReadProp(P:PReader);virtual;
    procedure WriteProp(P:PWriter);virtual;
  end;

const
  RPersistent: TStreamRec = (
    ObjType: 15001;
    VmtLink: Ofs(TypeOf(TPersistent)^);
    Load: @TPersistent.Load;
    Store: @TPersistent.Store);}

const
  PropAssignSepar = '=';

type
  PReader = ^TReader;
  TReader = object(TObject)
    constructor Init(AFileName:FNameStr);
    destructor Done;virtual;
    function Read:string;
    function ReadControl:PView;
    function ReadParamName:string;
    function ReadString:string;
    function ReadInteger:integer;
    function ReadBoolean:boolean;
    function CurValue:string;
    function ReadGroupedControl:PView;
    procedure ReadStringCollection(List:PCollection);
  private
    Owner:PReader;
    CurLine:Integer;
    Strings:PStrings;
    CurView:PView;
    constructor InternalInit(AOwner:PReader);
    procedure AssignPointers(V:PView);
    function Eof:boolean;
  end;

type
  PWriter = ^TWriter;
  TWriter = object(TObject)
    Modified:boolean;
    constructor Init(AFileName:FNameStr);
    destructor Done;virtual;
    procedure Write(const Str:string);
    procedure WriteProp(const Name:string;const Value:String);
    procedure WriteControl(View:PView);
    procedure WriteLink(const Name:string;const Link:PView);
    procedure WriteInteger(const Name:string;const Value:Longint);
    procedure WriteHex(const Name:string;const Value:Longint; const Digits:byte);
    procedure WritePString(const Name:string;const Value:PString);
    procedure WriteString(const Name:string;const Value:String);
    procedure WriteBoolean(const Name:string;const Value:boolean);
    procedure WriteStringCollection(const Name:string;const List:PCollection);
    procedure WriteGroup(Group:PGroup);
  private
    Owner:PWriter;
    Indent:integer;
    CurLine:Integer;
    FileName:PString;
    Strings:PStrings;
    constructor InternalInit(aOwner:PWriter);
    procedure WriteSubControl(View:PView);
  end;

type
  TWriteProcedure = procedure(Sender:PWriter; View:PView);
  TReadProcedure = procedure(Sender:PReader;var View:PView; Name:string);
  TAssignProperty = procedure(View:PView; Owner:PGroup);

type
  PReadWriteRecord = ^TReadWriteRecord;
  TReadWriteRecord = record
    ComponentType:byte;
    DoRead:TReadProcedure;
    DoWrite:TWriteProcedure;
    DoAssign:TAssignProperty;
    Next:PReadWriteRecord;
  end;

procedure RegisterReader(AComponentType:byte; ADoRead:TReadProcedure;
                                              ADoWrite:TWriteProcedure;
                                              ADoAssign:TAssignProperty);
procedure DisposeReaderTree;
implementation
uses Ext_Dos, Ext_Str, Ext_Math;

const
  ReaderTree: PReadWriteRecord = nil;

procedure RegisterReader(AComponentType:byte; ADoRead:TReadProcedure;
                                              ADoWrite:TWriteProcedure;
                                              ADoAssign:TAssignProperty);
var Node: PReadWriteRecord;
begin
  New(Node);
  Node^.Next:=ReaderTree;
  ReaderTree:=Node;
  Node^.ComponentType:=AComponentType;
  Node^.DoRead:=ADoRead;
  Node^.DoAssign:=ADoAssign;
  Node^.DoWrite:=ADoWrite;
end;

procedure DisposeReaderTree;
var Node: PReadWriteRecord;
begin
  while ReaderTree<>nil do
  begin
    Node:=ReaderTree^.Next;
    Dispose(ReaderTree);
    ReaderTree:=Node;
  end;
end;

function FindNode(ComponentType:integer):PReadWriteRecord;
var Node:PReadWriteRecord;
begin
  Node:=ReaderTree;
  while (Node<>nil) and (Node^.ComponentType<>ComponentType) do Node:=Node^.Next;
  FindNode:=Node;
end;

  { TWriter }
constructor TWriter.Init(AFileName:FNameStr);
begin
  inherited Init;
  FileName:=NewStr(AFileName);
  Strings:=New(PStrings, Init);
end;

constructor TWriter.InternalInit(aOwner:PWriter);
begin
  inherited Init;
  Owner:=AOwner;
  Indent:=Owner^.Indent+2;
  Strings:=Owner^.Strings;
end;

destructor TWriter.Done;
begin
  if Owner=nil then
  begin
    if Modified then Strings^.SaveToFile(FileName^);
    Dispose(Strings, Done);
    DisposeStr(FileName);
  end;
  inherited Done;
end;

procedure TWriter.Write(const Str:string);
begin
  Strings^.Add(DupChar(' ',Indent)+Str);
  Modified:=true;
end;

procedure TWriter.WriteProp(const Name:string;const Value:String);
begin
  Write(DupChar(' ',2)+Name+' '+PropAssignSepar+' '+Value);
end;

procedure TWriter.WriteControl(View:PView);
var Node: PReadWriteRecord;
begin
  Node:=FindNode(View^.ComponentType);
  if Node<>nil then
  begin
    Node^.DoWrite(@Self, View);
    Write('END;');
  end
  else Write('#Error: Component not found. Code:'+IntToStr( View^.ComponentType));
end;

procedure TWriter.WriteLink(const Name:string;const Link:PView);
begin
  WriteProp(Name, ComponentName(Link));
end;

procedure TWriter.WriteInteger(const Name:string;const Value:Longint);
begin
  WriteProp(Name,IntToStr(Value));
end;

procedure TWriter.WriteHex(const Name:string;const Value:Longint; const Digits:byte);
begin
  WriteProp(Name,'$'+IntToHex(Value, Digits));
end;

procedure TWriter.WritePString(const Name:string;const Value:PString);
begin
  WriteString(Name,DinamicStr(Value));
end;

procedure TWriter.WriteString(const Name:string;const Value:string);
begin
  WriteProp(Name, AddQuete(Value));
end;

procedure TWriter.WriteBoolean(const Name:string;const Value:boolean);
var s:string[5];
begin
  if Value then S:='true' else S:='false';
  WriteProp(Name, S);
end;

procedure TWriter.WriteStringCollection(const Name:string;const List:PCollection);
var i:integer;
    S:string[3];
begin
  if Assigned(List) then S:='' else S:='nil';
  WriteProp(Name,S);
  if List=nil then exit;
  inc(Indent,2);
  WriteInteger('Count',List^.Count);
  for i:=0 to List^.Count-1 do
    WritePString('Item'+IntToStr(i), List^.At(i));
  Dec(Indent,2);
end;


procedure TWriter.WriteGroup(Group:PGroup);
var V:PView;
begin
  if Group^.Last <> nil then
  begin
     V := Group^.Last;
     repeat
       if not (V^.ComponentType in SystemTypeSet) then
          WriteSubControl(V);
       V := V^.Prev;
     until V = Group^.Last;
  end;
end;

procedure TWriter.WriteSubControl(View:PView);
var Writer:PWriter;
begin
  Writer:=New(PWriter, InternalInit(@Self));
  Writer^.WriteControl(View);
  Writer^.Free;
end;

 { TReader }
constructor TReader.Init(AFileName:FNameStr);
begin
  inherited Init;
  Strings:=New(PStrings, Init);
  Strings^.LoadFromFile(AFileName);
end;

constructor TReader.InternalInit(AOwner:PReader);
begin
  inherited Init;
  Owner:=AOwner;
  Strings:=Owner^.Strings;
end;

destructor TReader.Done;
begin
  if Owner=nil then
  begin
    Dispose(Strings, Done);
  end;
  inherited Done;
end;

function CreateViewByName(Name:string; var Node:PReadWriteRecord):PView;
var V:PView;

begin
  Node:=ReaderTree;
  V:=nil;
  while (Node<>nil) or (V<>nil) do
  begin
    if Assigned(Node^.DoRead) then Node^.DoRead( nil, V, Name);
    if V=nil then Node:=Node^.Next;
  end;
  CreateViewByName:=V;
end;

function TReader.Read:string;
begin
  Read:=Strings^.Str(CurLine);
end;

function TReader.ReadParamName:string;
var S:string;
    i:Integer;
begin
  S:=stLoCase(Strings^.Str(CurLine));
  i:=Pos(PropAssignSepar,S);
  if i<>0 then ReadParamName:=Trim(Copy(S,1,i-1))
  else
  begin
    i:=Pos('end;',S);
    if i=0 then i:=Pos(' ',S) else i:=i+1;
    S:=Copy(S,1,i-1);
    if (S<>'') and (S<>'object') and (S<>'end;') then S:='';
  end;
end;

procedure TReader.AssignPointers(V:PView);
begin
end;

function TReader.ReadControl:PView;
var S:string;
    I:integer;
    Node:PReadWriteRecord;
begin
  if Owner<>nil then S:=ReadParamName
  else
  begin
    S:='';
    CurLine:=-1;
  end;
  while (S<>'object') and not Eof do
  begin
    inc(CurLine);
    S:=ReadParamName;
    i:=Pos(' ',S);
    if I<>0 then S:=Copy(S,1,i-1);
  end;
  if not Eof then
  begin
    S:=stLoCase(Trim(Read));
    Delete(S,1,I);
    i:=Pos(':',S);
    CurView:=CreateViewByName(TrimLeft(Copy(S,I+1,255)), Node);
    if CurView<>nil then
    begin
      Delete(S,i,255);
      S:=Trim(S);
      AssignStr(CurView^.ComponentName, S);
      inc(CurLine);
      while (Pos('END;',stUpCase(Read))<>0) and not Eof do
      begin
        Node^.DoRead(@Self, CurView, ReadParamName);
        inc(CurLine);
      end;
    end;
  end;
  if (CurView<>nil) and (Owner=nil) then AssignPointers(CurView);
  ReadControl:=CurView;
end;

function TReader.Eof:boolean;
begin
  Eof:=CurLine>=Strings^.Count;
end;

procedure TReader.ReadStringCollection(List:PCollection);
begin
end;

function TReader.ReadString;
begin
  ReadString:=DelQuete(CurValue);
end;

function TReader.ReadInteger;
begin
  ReadInteger:=StrToInt(CurValue);
end;

function TReader.ReadBoolean;
var S:string[1];
begin
  S:=CurValue;
  ReadBoolean:=S[1] in ['t','T'];
end;

function TReader.ReadGroupedControl:PView;
var R:PReader;
    V:PView;
    BeginCount:integer;
begin
  V:=nil;
  if ReadParamName='object' then
  begin
    R:=New(PReader, InternalInit(@Self));
    V:=R^.ReadControl;
    R^.Free;
    if V=nil then
    begin
      BeginCount:=1;
      while (BeginCount<>0) and (not Eof) do
      begin
        if ReadParamName='end;' then Dec(BeginCount);
        if ReadParamName='object' then inc(BeginCount);
      end;
    end;
  end;
  ReadGroupedControl:=V;
end;

function TReader.CurValue:string;
var S:string;
begin
  S:=Strings^.Str(CurLine);
  CurValue:=Trim(Copy(S,Pos(PropAssignSepar,S)+1,255));
end;

  { TPropObject }
constructor TPropObject.Init(AName:string);
begin
  inherited Init;
  Name:=NewStr(AName);
end;

constructor TPropObject.Load(var S:TStream);
begin
  inherited Init;
  Name:=S.ReadStr;
  S.Read(DateType, SizeOf(TPropType));
end;

destructor TPropObject.Done;
begin
  DisposeStr(Name);
  inherited Done;
end;
procedure TPropObject.Store(var S:TStream);
begin
end;
function TPropObject.AsString:string;
begin
 abstract;
end;
function TPropObject.AsInteger:integer;
begin
 abstract;
end;
function TPropObject.AsBoolean:boolean;
begin
 abstract;
end;
function TPropObject.AsFloat:Double;
begin
 abstract;
end;
function TPropObject.DataSize:word;
begin
 abstract;
end;
procedure TPropObject.AsBlob(var Buffer);
begin
 abstract;
end;
procedure TPropObject.SetAsString;
begin
 abstract;
end;
procedure TPropObject.SetAsInteger;
begin
 abstract;
end;
procedure TPropObject.SetAsBoolean;
begin
 abstract;
end;
procedure TPropObject.SetAsFloat;
begin
 abstract;
end;
procedure TPropObject.SetAsBlob(var Buffer);
begin
 abstract;
end;
(*
  { TReader }
constructor TReader.Init(var S:TStream);
begin
  inherited Init;
end;

destructor TReader.Done;
begin
  inherited Done;
end;

  { TWriter }
constructor TWriter.Init;
begin
  inherited Init;
end;

destructor TWriter.Done;
begin
  inherited Done;
end;

procedure TWriter.Store(var S:TStream);
begin
end;

  { TPersistent }
constructor TPersistent.Init;
begin
  inherited Init;
end;

constructor TPersistent.Load(var S:TStream);
begin
  inherited Init;
end;

destructor TPersistent.Done;
begin
  inherited Done;
end;

procedure TPersistent.Store(var S:TStream);
begin
end;

procedure TPersistent.ReadProp(P:PReader);
begin
end;

procedure TPersistent.WriteProp(P:PWriter);
begin
end;
*)
end.